#include <iostream>

using namespace std;

#include "List.H"
class parentRTS;
List<parentRTS* (*)(int)> parentRTSFuncPtr_(0);
List<string> parentRTSString_(0);

class parentRTS
{
public:
    parentRTS()
    {
        cout << "This is parentRTS class\n";
    }
    static parentRTS* New(string lookup)
    {
        int nT;
        for(int i=0;i<parentRTSFuncPtr_.size();i++)
        {
            if(lookup==parentRTSString_[i])
            {
                parentRTS* pList = (*parentRTSFuncPtr_[i])(nT);
                return pList;
            }
        }
    }
};

class child1RTS
:
    public parentRTS
{
public:
    static string typeName()
    {
        return "child1";
    }
    child1RTS(int nT)
    {
        cout << "This is child1RTS class\n";
    }
};

class child2RTS
:
    public parentRTS
{
public:
    static string typeName()
    {
        return "child2";
    }
    child2RTS(int nT)
    {
        cout << "This is child2RTS class\n";
    }
};
template<class Type>
class addpatchConstructorToTable
{
public:
    static parentRTS* New(int nT)
    {
        cout << "This is New function in addpatchConstructorToTable class\n";
        return (new Type(nT));
    }
    addpatchConstructorToTable()
    {
        parentRTS* (*RTSfunction)(int);
        RTSfunction=New;
        parentRTSFuncPtr_.setSize(parentRTSFuncPtr_.size()+1);
        parentRTSFuncPtr_[parentRTSFuncPtr_.size()-1]=RTSfunction;
        parentRTSString_.setSize(parentRTSString_.size()+1);
        parentRTSString_[parentRTSString_.size()-1]=Type::typeName();
    }
};

addpatchConstructorToTable<child1RTS> reg_child1RTS;
addpatchConstructorToTable<child2RTS> reg_child2RTS;

int main()
{
    int temp=5;
    parentRTS::New("child2");
    parentRTS::New("child1");

    return 0;
}
