template <class T>
class fvPatchField;

template <class T>
class zeroGradientFvPatchField
:
    public fvPatchField<T>
{
public:
    static const string typeName()
    {
        return "zeroGradient";
    }
    zeroGradientFvPatchField(const List<T>& field, const int& nPatch, istream& is)
    :
        fvPatchField<T>(nPatch)
    {}
    virtual void updateCoeffs(const double& value)
    {
        for(int i=0;i<this->size();i++) this->operator[](i)=value;
    }
};

