class IOobject
{
private:
    string fileName_;
    string pathName_;
    bool readOption_;
    bool writeOption_;
public:
    IOobject
    (
        string fileName, 
        string pathName, 
        bool readOption=false,
        bool writeOption=true
    )
    :
        fileName_(fileName),
        pathName_(pathName),
        readOption_(readOption),
        writeOption_(writeOption)
    {}
    string fileName()
    {
        return fileName_;
    }
    string pathName()
    {
        return pathName_;
    }
    bool readOption()
    {
        return readOption_;
    }
    bool writeOption()
    {
        return writeOption_;
    }
};

