template <class T>
class List
{
private:
    T* v_;
    int size_;
public:
    List()
    :
        size_(0),
        v_(NULL)
    {}
    List(int s)
    :
        size_(0),
        v_(NULL)
    {
        this->setSize(s);
        size_=s;
    }
    List(int s, T v)
    :
        size_(0),
        v_(NULL)
    {
        this->setSize(s);
        size_=s;
        for(int i=0;i<size_;i++) v_[i]=v;
    }
    void setSize(const int newSize)
    {
        T* vv=new T[newSize];
        if(this->size_)
        {
            int minSize = min(this->size_, newSize);
            T* v1=&this->v_[minSize];
            T* v2=&vv[minSize];
            while(minSize--) *--v2=*--v1;
        }
        if(this->v_) delete[] this->v_;
        this->size_=newSize;
        this->v_=vv;
    }
    T& operator[](int s)
    {
        return v_[s];
    }
    int size()
    {
        return size_;
    }
};

