template <class T>
class PtrList
{
private:
    List<T*> ptrs_;
public:
    PtrList()
    :
        ptrs_()
    {}
    PtrList(int s)
    :
        ptrs_()
    {
        this->setSize(s);
    }

    void setSize(const int newSize)
    {
        int oldSize = size();
        if(newSize < oldSize) ptrs_.setSize(newSize);
        else if(newSize > oldSize)
        {
            ptrs_.setSize(newSize);
            for(int i=oldSize;i<newSize;i++) ptrs_[i]=NULL;
        }
    }
    T& operator[](int s)
    {
        return *(ptrs_[s]);
    }
    int size()
    {
        return ptrs_.size();
    }
    void set(const int i, T* ptr)
    {
        this->ptrs_[i] = ptr;
    }
};

