template <class T>
class fixedValueFvPatchField
:
    public fvPatchField<T>
{
private:
    T fixedValue_;
public:
    static const string typeName()
    {
        return "fixedValue";
    }
    fixedValueFvPatchField(const List<T>& field, const int& nPatch, istream& is)
    :
        fvPatchField<T>(nPatch) 
    {
        is >> fixedValue_;
        for(int i=0;i<this->size();i++) this->operator[](i)=fixedValue_;
    }
    virtual void updateCoeffs(const double& value)
    {
        for(int i=0;i<this->size();i++) this->operator[](i)=fixedValue_;
    }
};
